package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class TitleState extends FlxState
	{
		[Embed(source = "data/pattern1.png")] public static var ImgPattern:Class;
		[Embed(source = "data/pattern2.png")] public static var ImgPattern2:Class;
		[Embed(source = "data/pattern3.png")] public static var ImgPattern3:Class;
		[Embed(source = "data/pattern4.png")] public static var ImgPattern4:Class;
		[Embed(source = "data/pattern5.png")] public static var ImgPattern5:Class;
		[Embed(source = "data/pattern6.png")] public static var ImgPattern6:Class;
		[Embed(source = "data/pattern7.png")] public static var ImgPattern7:Class;
		[Embed(source = "data/pattern8.png")] public static var ImgPattern8:Class;
			
		public var bullets :FlxGroup;
		public var player:FlxSprite;
		public var playerdead:Boolean;
		public var time:Number;
		public static var initpx:int;
		public static var initpy:int;
		public static var loadinit:Boolean=false;
		
		override public function create() : void
		{
			playerdead=false;
			var data : Bitmap;
			switch (FlxG.level)
			{
				case 0:
					data = new ImgPattern();
					break;
				case 1:
					data = new ImgPattern2();
					break;
				case 2:
					data = new ImgPattern3();
					break;
				case 3:
					data = new ImgPattern4();
					break;
				case 4:
					data = new ImgPattern5();
					break;
				case 5:
					data = new ImgPattern6();
					break;
				case 6:
					data = new ImgPattern7();
					break;
				case 7:
					data = new ImgPattern8();
					break;
				case 8:
					FlxG.state = new EndState();
					data = new ImgPattern8();
					break;
				
			}
			bullets = new FlxGroup();
			this.add(bullets);
			time=0;
			for (var i:int=0;i<data.bitmapData.width;i++)
			{
				for (var j:int=0;j<data.bitmapData.height;j++)
				{
					if (data.bitmapData.getPixel(i,j)!=0x000000)
					{
						var a:Number=Math.random()*3.1415926535*2;
						var d:Number = Math.sqrt(FlxG.width*FlxG.width/4+FlxG.height*FlxG.height/4);
						var px:Number = 
							FlxG.width/2+(Math.random()<0.5?1:-1)*(Math.cos(a)*d);
						var py:Number = 
							FlxG.height/2+(Math.random()<0.5?1:-1)*(Math.sin(a)*d);
						
						var tx:Number = 10*i+(800-500)/2;
						var ty:Number = 10*j+(600-500)/2;
						
						var vx:Number=tx-px;
						var vy:Number=ty-py;
						
						var s:Bullet = new Bullet(px,py,tx,ty,data.bitmapData.getPixel32(i,j));
						bullets.add(s);
					}
				}
			}
			
			player = new FlxSprite(FlxG.width/2,FlxG.height/2);
			player.createGraphic(3,3,0xffffffff);
			
			if (loadinit)
			{
				loadinit=false;
				player.x=initpx;
				player.y=initpy;
			}
			//this.add(player);
		}
		
		override public function update() : void
		{
			if (playerdead)
			{
				FlxG.state = new TitleState();
				FlxG.play(StartState.SndBlip2).survive=true;
			}
			time+=FlxG.elapsed;
			if (time>30)
			{
				loadinit=true;
				initpx=player.x;
				initpy=player.y;
				FlxG.level++;
				FlxG.state = new TitleState();	
				FlxG.play(StartState.SndBlip).survive=true;	
			}
			
			if ( FlxG.keys.pressed("UP") )
			{
				player.y-=FlxG.elapsed*100;
				if (player.y<0)
					playerdead=true;
			}
			if ( FlxG.keys.pressed("DOWN") )
			{
				player.y+=FlxG.elapsed*100;
				if (player.y>=FlxG.height)
					playerdead=true;
				
			}
			if ( FlxG.keys.pressed("LEFT") )
			{
				player.x-=FlxG.elapsed*100;
				if (player.x<0)
					playerdead=true;
				
			}
			if ( FlxG.keys.pressed("RIGHT") )
			{
				player.x+=FlxG.elapsed*100;
				if (player.x>=FlxG.width)
					playerdead=true;			
			}
			
			super.update();
		}
		
		override public function postProcess() : void
		{
			if (FlxG.buffer.getPixel(player.x,player.y)!=0)
				playerdead=true;
			
			player.render();
		
		}
	}
}

import org.flixel.*;
class Bullet extends FlxSprite
{
	public var from:FlxPoint;
	public var to:FlxPoint;
	public var t:Number;
	
	public function Bullet(fx:Number,fy:Number,tx:Number,ty:Number,col:uint):void
	{
		super(x,y);
		from = new FlxPoint(fx,fy);
		to=new FlxPoint(tx,ty);
		t=-Math.random()*3;
		this.moves=false;
		this.solid=true;
		this.fixed=true;
		this.createGraphic(5,5,col);
	}
	
	override public function update():void
	{
		t+=FlxG.elapsed/3;
		
		if (t<5)
		{
			this.x=from.x+Math.min(t,1)*(to.x-from.x);
			this.y=from.y+Math.min(t,1)*(to.y-from.y);
		}
		else
		{
			this.x=to.x+(t-5)*(to.x-from.x);
			this.y=to.y+(t-5)*(to.y-from.y);			
		}		
		
		super.update();
	}
}